/* Copyright (C) 1990, 1993 Free Software Foundation, Inc.

   This file is part of GNU ISPELL.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "charset.h"

/* this tables has two entries per character code.  The first
 * one is used if the entry is for an alphabetic character,
 * and gives the lower case character that has the same
 * accent marks.
 *
 * The second code tells whether the character is part of a word.
 * Normally, all alphabetic characters and the apostrophy have
 * a 1.
 */

/* charset table for IBM-PC console */
struct charset charset[] =
{
  /* 00 */ 
 {0, 0},
 /* 01 */ 
 {0, 0},
 /* 02 */ 
 {0, 0},
 /* 03 */ 
 {0, 0},
 /* 04 */ 
 {0, 0},
 /* 05 */ 
 {0, 0},
 /* 06 */ 
 {0, 0},
 /* 07 */ 
 {0, 0},
 /* 08 */ 
 {0, 0},
 /* 09 */ 
 {0, 0},
 /* 10 */ 
 {0, 0},
 /* 11 */ 
 {0, 0},
 /* 12 */ 
 {0, 0},
 /* 13 */ 
 {0, 0},
 /* 14 */ 
 {0, 0},
 /* 15 */ 
 {0, 0},
 /* 16 */ 
 {0, 0},
 /* 17 */ 
 {0, 0},
 /* 18 */ 
 {0, 0},
 /* 19 */ 
 {0, 0},
 /* 20 */ 
 {0, 0},
 /* 21 */ 
 {0, 0},
 /* 22 */ 
 {0, 0},
 /* 23 */ 
 {0, 0},
 /* 24 */ 
 {0, 0},
 /* 25 */ 
 {0, 0},
 /* 26 */ 
 {0, 0},
 /* 27 */ 
 {0, 0},
 /* 28 */ 
 {0, 0},
 /* 29 */ 
 {0, 0},
 /* 30 */ 
 {0, 0},
 /* 31 */ 
 {0, 0},
 /* 32 space */ 
 {0, 0},
 /* 33 ! */ 
 {0, 0},
 /* 34 " */ 
 {0, 0},
 /* 35 # */ 
 {0, 0},
 /* 36 $ */ 
 {0, 0},
 /* 37 % */ 
 {0, 0},
 /* 38 & */ 
 {0, 0},
 /* 39 ' */ 
 {'\'', 1},
 /* 40 ( */ 
 {0, 0},
 /* 41 ) */ 
 {0, 0},
 /* 42 * */ 
 {0, 0},
 /* 43 + */ 
 {0, 0},
 /* 44 , */ 
 {0, 0},
 /* 45 - */ 
 {0, 0},
 /* 46 . */ 
 {0, 0},
 /* 47 / */ 
 {0, 0},
 /* 48 0 */ 
 {0, 0},
 /* 49 1 */ 
 {0, 0},
 /* 50 2 */ 
 {0, 0},
 /* 51 3 */ 
 {0, 0},
 /* 52 4 */ 
 {0, 0},
 /* 53 5 */ 
 {0, 0},
 /* 54 6 */ 
 {0, 0},
 /* 55 7 */ 
 {0, 0},
 /* 56 8 */ 
 {0, 0},
 /* 57 9 */ 
 {0, 0},
 /* 58 : */ 
 {0, 0},
 /* 59 ; */ 
 {0, 0},
 /* 60 < */ 
 {0, 0},
 /* 61 = */ 
 {0, 0},
 /* 62 > */ 
 {0, 0},
 /* 63 ? */ 
 {0, 0},
 /* 64 @ */ 
 {0, 0},
 /* 65 A */ 
 {'a', 1},
 /* 66 B */ 
 {'b', 1},
 /* 67 C */ 
 {'c', 1},
 /* 68 D */ 
 {'d', 1},
 /* 69 E */ 
 {'e', 1},
 /* 70 F */ 
 {'f', 1},
 /* 71 G */ 
 {'g', 1},
 /* 72 H */ 
 {'h', 1},
 /* 73 I */ 
 {'i', 1},
 /* 74 J */ 
 {'j', 1},
 /* 75 K */ 
 {'k', 1},
 /* 76 L */ 
 {'l', 1},
 /* 77 M */ 
 {'m', 1},
 /* 78 N */ 
 {'n', 1},
 /* 79 O */ 
 {'o', 1},
 /* 80 P */ 
 {'p', 1},
 /* 81 Q */ 
 {'q', 1},
 /* 82 R */ 
 {'r', 1},
 /* 83 S */ 
 {'s', 1},
 /* 84 T */ 
 {'t', 1},
 /* 85 U */ 
 {'u', 1},
 /* 86 V */ 
 {'v', 1},
 /* 87 W */ 
 {'w', 1},
 /* 88 X */ 
 {'x', 1},
 /* 89 Y */ 
 {'y', 1},
 /* 90 Z */ 
 {'z', 1},
 /* 91 [ */ 
 {0, 0},
 /* 92 \ */ 
 {0, 0},
 /* 93 ] */ 
 {0, 0},
 /* 94 ^ */ 
 {0, 0},
 /* 95 _ */ 
 {0, 0},
 /* 96 ` */ 
 {0, 0},
 /* 97 a */ 
 {'a', 1},
 /* 98 b */ 
 {'b', 1},
 /* 99 c */ 
 {'c', 1},
 /* 100 d */ 
 {'d', 1},
 /* 101 e */ 
 {'e', 1},
 /* 102 f */ 
 {'f', 1},
 /* 103 g */ 
 {'g', 1},
 /* 104 h */ 
 {'h', 1},
 /* 105 i */ 
 {'i', 1},
 /* 106 j */ 
 {'j', 1},
 /* 107 k */ 
 {'k', 1},
 /* 108 l */ 
 {'l', 1},
 /* 109 m */ 
 {'m', 1},
 /* 110 n */ 
 {'n', 1},
 /* 111 o */ 
 {'o', 1},
 /* 112 p */ 
 {'p', 1},
 /* 113 q */ 
 {'q', 1},
 /* 114 r */ 
 {'r', 1},
 /* 115 s */ 
 {'s', 1},
 /* 116 t */ 
 {'t', 1},
 /* 117 u */ 
 {'u', 1},
 /* 118 v */ 
 {'v', 1},
 /* 119 w */ 
 {'w', 1},
 /* 120 x */ 
 {'x', 1},
 /* 121 y */ 
 {'y', 1},
 /* 122 z */ 
 {'z', 1},
 /* 123 { */ 
 {0, 0},
 /* 124 | */ 
 {0, 0},
 /* 125 } */ 
 {0, 0},
 /* 126 ~ */ 
 {0, 0},
 /* 127 DEL */ 
 {0, 0},
 /* 128 */ 
 {0207, 1},
 /* 129 */ 
 {0201, 1},			/* u umlaut */
 /* 130 */ 
 {0202, 1},			/* e acute */
 /* 131 */ 
 {0203, 1},			/* a hat */
 /* 132 */ 
 {0204, 1},			/* a umlaut */
 /* 133 */ 
 {0205, 1},			/* a grave */
 /* 134 */ 
 {0206, 1},			/* a circle */
 /* 135 */ 
 {0207, 1},			/* c cidella */
 /* 136 */ 
 {0210, 1},			/* e hat */
 /* 137 */ 
 {0211, 1},			/* e umlaut */
 /* 138 */ 
 {0212, 1},			/* e grave */
 /* 139 */ 
 {0213, 1},			/* i umlaut */
 /* 140 */ 
 {0214, 1},			/* i hat */
 /* 141 */ 
 {0215, 1},			/* i grave */
 /* 142 */ 
 {0204, 1},			/* A umulat */
 /* 143 */ 
 {0206, 1},			/* A circle */
 /* 144 */ 
 {0202, 1},			/* E acute */
 /* 145 */ 
 {0221, 1},			/* ae */
 /* 146 */ 
 {0221, 1},			/* AE */
 /* 147 */ 
 {0223, 1},			/* o hat */
 /* 148 */ 
 {0224, 1},			/* o umlaut */
 /* 149 */ 
 {0225, 1},			/* o grave */
 /* 150 */ 
 {0226, 1},			/* u circumflex */
 /* 151 */ 
 {0227, 1},			/* u grave */
 /* 152 */ 
 {0230, 1},			/* y umlaut */
 /* 153 */ 
 {0224, 1},			/* O umulaut */
 /* 154 */ 
 {0201, 1},			/* U umulaut */
 /* 155 */ 
 {0, 0},			/* cents */
 /* 156 */ 
 {0, 0},			/* pounds sterling */
 /* 157 */ 
 {0, 0},			/* yen */
 /* 158 */ 
 {0, 0},			/* Pt */
 /* 159 */ 
 {0, 0},			/* f (francs?) */
 /* 160 */ 
 {0240, 1},			/* a acute */
 /* 161 */ 
 {0241, 1},			/* i acute */
 /* 162 */ 
 {0242, 1},			/* o acute */
 /* 163 */ 
 {0243, 1},			/* u acute */
 /* 164 */ 
 {0244, 1},			/* n tilde */
 /* 165 */ 
 {0244, 1},			/* N tilde */
 /* 166 */ 
 {0, 0},
 /* 167 */ 
 {0, 0},
 /* 168 */ 
 {0, 0},			/* upside down ? */
 /* 169 */ 
 {0, 0},
 /* 170 */ 
 {0, 0},
 /* 171 */ 
 {0, 0},
 /* 172 */ 
 {0, 0},
 /* 173 */ 
 {0, 0},			/* upside down ! */
 /* 174 */ 
 {0, 0},			/* << */
 /* 175 */ 
 {0, 0},			/* >> */
 /* 176 */ 
 {0, 0},
 /* 177 */ 
 {0, 0},
 /* 178 */ 
 {0, 0},
 /* 179 */ 
 {0, 0},
 /* 180 */ 
 {0, 0},
 /* 181 */ 
 {0, 0},
 /* 182 */ 
 {0, 0},
 /* 183 */ 
 {0, 0},
 /* 184 */ 
 {0, 0},
 /* 185 */ 
 {0, 0},
 /* 186 */ 
 {0, 0},
 /* 187 */ 
 {0, 0},
 /* 188 */ 
 {0, 0},
 /* 189 */ 
 {0, 0},
 /* 190 */ 
 {0, 0},
 /* 191 */ 
 {0, 0},
 /* 192 */ 
 {0, 0},
 /* 193 */ 
 {0, 0},
 /* 194 */ 
 {0, 0},
 /* 195 */ 
 {0, 0},
 /* 196 */ 
 {0, 0},
 /* 197 */ 
 {0, 0},
 /* 198 */ 
 {0, 0},
 /* 199 */ 
 {0, 0},
 /* 200 */ 
 {0, 0},
 /* 201 */ 
 {0, 0},
 /* 202 */ 
 {0, 0},
 /* 203 */ 
 {0, 0},
 /* 204 */ 
 {0, 0},
 /* 205 */ 
 {0, 0},
 /* 206 */ 
 {0, 0},
 /* 207 */ 
 {0, 0},
 /* 208 */ 
 {0, 0},
 /* 209 */ 
 {0, 0},
 /* 210 */ 
 {0, 0},
 /* 211 */ 
 {0, 0},
 /* 212 */ 
 {0, 0},
 /* 213 */ 
 {0, 0},
 /* 214 */ 
 {0, 0},
 /* 215 */ 
 {0, 0},
 /* 216 */ 
 {0, 0},
 /* 217 */ 
 {0, 0},
 /* 218 */ 
 {0, 0},
 /* 219 */ 
 {0, 0},
 /* 220 */ 
 {0, 0},
 /* 221 */ 
 {0, 0},
 /* 222 */ 
 {0, 0},
 /* 223 */ 
 {0, 0},
 /* 224 */ 
 {0, 0},			/* alpha */
 /* 225 */ 
 {0, 0},			/* beta */
 /* 226 */ 
 {0, 0},			/* gamma */
 /* 227 */ 
 {0, 0},			/* pi */
 /* 228 */ 
 {0, 0},			/* capital sigma */
 /* 229 */ 
 {0, 0},			/* little sigma */
 /* 230 */ 
 {0, 0},			/* mu */
 /* 231 */ 
 {0, 0},
 /* 232 */ 
 {0, 0},
 /* 233 */ 
 {0, 0},			/* theta */
 /* 234 */ 
 {0, 0},			/* omega */
 /* 235 */ 
 {0, 0},			/* delta */
 /* 236 */ 
 {0, 0},
 /* 237 */ 
 {0, 0},
 /* 238 */ 
 {0, 0},			/* epsilon */
 /* 239 */ 
 {0, 0},
 /* 240 */ 
 {0, 0},
 /* 241 */ 
 {0, 0},
 /* 242 */ 
 {0, 0},
 /* 243 */ 
 {0, 0},
 /* 244 */ 
 {0, 0},
 /* 245 */ 
 {0, 0},
 /* 246 */ 
 {0, 0},
 /* 247 */ 
 {0, 0},
 /* 248 */ 
 {0, 0},
 /* 249 */ 
 {0, 0},
 /* 250 */ 
 {0, 0},
 /* 251 */ 
 {0, 0},
 /* 252 */ 
 {0, 0},
 /* 253 */ 
 {0, 0},
 /* 254 */ 
 {0, 0},
 /* 255 */ 
 {0, 0},
};
